<?php
/**
 * oInteger
 *
 * return oInteger object
 *
 * @access  public
 * @param   integer   $var
 * @return  Object_Integer  
 */
function oInteger($var) 
{
	require_once 'Object/Integer.php';
    return new Object_Integer($var);
}

/**
 * oString
 *
 * return oString object
 *
 * @access  public
 * @param   string   $string  param_descr
 * @return  Object_String
 */
function oString($string = '') 
{
	require_once 'Object/String.php';
	return new Object_String($string);
}

/**
 * oUrl
 *
 * return oString object
 *
 * @access  public
 * @param   string   $string  param_descr
 * @return  Object_Url
 */
function oUrl($string = '') 
{
	require_once 'Object/String.php';
	require_once 'Object/Url.php';
	return new Object_Url($string);
}

/**
 * oArray
 *
 * return oArray object
 *
 * @access  public
 * @param   $var
 * @return  Object_Array
 */
function oArray($var = null) 
{
	require_once 'Object/Array.php';
	
    if (func_num_args() == 1) {
        if (is_array($var)) {
            return new Object_Array($var);
        } elseif (is_null($var)) {
            return new Object_Array(array($var));
        } else {
            return new Object_Array(array());
        }
    } else {        
       return new Object_Array(func_get_args());
    }
}
