<?php
/**
 * Class Object_Library
 *
 * organize library
 *
 * @access   public
 * @category Object
 * @package  Object_Library
 * 
 * @access   public
 * @author   dark
 * @version  $Id: Library.php Thu Nov 20 17:07:05 EET 2008 dark$
 */
class Object_Library 
{
    static $libs = array(
                        OBJECT_TYPE_ARRAY   => array(),
                        OBJECT_TYPE_INTEGER => array(),
                        OBJECT_TYPE_STRING  => array(),
                        OBJECT_TYPE_URL     => array(),
    
                    );
    
    /**
     * import
     *
     * @access  public
     * @param   string $library
     */
    static function import($library) 
    {
        list($type, $lib) = split('/', $library);
        
        $type  = ucfirst(strtolower($type));
        $lib   = ucfirst(strtolower($lib));
        
        $file  = $type .'/'. $lib .'.php';
        
        if (isset(Object_Library::$libs[$type])) {
            if (in_array($lib, Object_Library::$libs[$type])) {
                return true;
            } elseif (!file_exists(OBJECT_PATH . '/'. $file)) {
                throw new Exception('Library "'.$library.'" is not exist');
            } else {
                array_push(Object_Library::$libs[$type], $lib);
            }
        } else {
            throw new Exception('Type "'.$type.'" is undefined');
        }
    }
    
    /**
     * exist
     *
     * check methods in library
     *
     * @access  public
     * @param   string   $method  method name
     * @return  void  
     */
    public function exist($type, $method) 
    {
        if (!isset(Object_Library::$libs[$type]) or sizeof(Object_Library::$libs[$type]) == 0) {
            return false;
        }
        
        foreach (Object_Library::$libs[$type] as $lib) {
            $file  = $type .'/'. $lib .'.php';
            $class = 'Object_'. $type .'_'. $lib;
            
            require_once OBJECT_PATH . '/'. $type .'/'. $lib .'.php';
            
            if (!class_exists($class)) {
                break;
            }
            
            if (is_callable(array($class, $method))) {
                return $class;
            }
        }
        
        return false;
    }
}


/**
 * import
 *
 * import library
 *
 * @access  public
 * @param   string     $library
 * @return  void
 */
function import($library) 
{
    require_once 'Object/Library.php';
    return Object_Library::import($library);
}

//import('String/Html');
//$res[] = Object_Library::exist('String', 'html_encode');