<?php
/**
 * Class Object_Object
 *
 * object wrapper
 *
 * @access   public
 * @category Object
 * @package  Object_Object
 * 
 * @access   public
 * @author   dark
 * @version  $Id: Object.php Fri Nov 21 12:20:11 EET 2008 dark$
 */
class Object_Object 
{
    /**
     * __get
     *
     * unversal getter
     *
     * @access  public
     * @param   string     $var  variable name
     * @return  Object_Object
     */
    public function __get($var) 
    {
        if ($this->__isset($var)) {
            
            $method = 'get'.ucfirst($var);
            
            if (method_exists($this, $method)) {
                return $this->$method();
            } else {
                return $this->$var;
            }
        }
        throw new Exception("Unrecognized attribute '$name'");
    }
    
    /**
     * __set
     *
     * unversal setter
     *
     * @access  public
     * @param   string     $var  variable name
     * @param   string     $val  variable value
     * @return  Object_Object
     */
    public function __set($var, $val) 
    {
        if ($this->__isset($var)) {
            
            $method = 'set'.ucfirst($var);
            
            if (method_exists($this, $method)) {
                $this->$method($val);
            } else {
                $this->$var = $val;
            }
            
            return $this;
        }
        throw new Exception("Unrecognized attribute '$var'");
    }
    
    /**
     * __isset
     *
     * universal isset
     *
     * @access  public
     * @param   string     $var  variable name
     * @return  void    
     */
    public function __isset($var) 
    {
        if (strpos($var, '_') === 0) {
            return false;
        }
        return property_exists($this, $var);
    }
}