<?php
/**
 * Class oString
 *
 * object model for string
 *
 * @author   Anton Shevchuk <AntonShevchuk@gmail.com>
 * @link     http://anton.shevchuk.name
 * @access   public
 * @category Object
 * @package  Object_Url
 * @created  Tue Oct 28 10:57:25 EET 2008
 */
require_once 'String.php';

class Object_Url extends Object_String
{
    /**
     * parse
     *
     * parse wrapper
     *
     * @access  public
     * @param   integer $component
     * @return  Object_String|Object_Array
     */
    public function parse($component = null) 
    {
        if ($component) {
            return oString(parse_url($this->var, $component));
        } else {
            return oArray(parse_url($this->var));
        }
    }
    
    /**
     * encode
     *
     * urlencode wrapper
     *
     * @access  public
     * @return  Object_Url
     */
    public function encode() 
    {
        $this->var = urlencode($this->var);
        return $this;
    }
    
    /**
     * decode
     *
     * urldecode wrapper
     *
     * @access  public
     * @return  Object_Url
     */
    public function decode() 
    {
        $this->var = urldecode($this->var);
        return $this;
    }
}